Subject: Re: [Sigtran] M3UA AS override mode from SGP perspective

From: Mikhail Plotkin <[email-masked]>
Date: Fri, 01 Oct 2010 16:38:07 +0400

Thanks, Chris and Brian!
What I understood is that in my configuration there could be only one active SCTP association, but in general case there could be more active SCTP associations depending on how many SGPs are connected with the active ASP. That's clear.

Then another question. According to RFC4666 Appendix A, it is possible to have SGP1 and SGP2 distributed between two hosts. So, ASP1 may activate in SGP1 and then ASP3 may activate in SGP2. If SGP1 and SGP2 have no inter-communication, ASP1 will not receive Notify (Alternative ASP active), so there will be two active ASPs in the AS which contradicts to the override concept.
How should this issue be solved? By management layer at the ASP side or by some kind of inter-communication between SGPs?

Best regards,
Mikhail.

> Mikhail,

> 
> Please see comments below:
> 
> Mikhail Plotkin wrote:                     (Fri, 01 Oct 2010 01:19:32)
> > 
> > Local Side                         Remote Side
> >                                    +------------+
> >               -------assoc11-------|ASP_1       |
> > +----------+ /                     |            |
> > |     SGP_1| --------assoc12-------|ASP_2       |
> > |          |                       |            |
> > | SG       |                       |        AS  |
> > |          |                       |            |
> > |     SGP_2| --------assoc23-------|ASP_3       |
> > +----------+ \                     |            |
> >               -------assoc24-------|ASP_4       |
> >                                    +------------+
> > 
> > If the AS works in an Override mode, then how many associations (max)
> > may be simultaneously active in this configuration?
> 
> 1. The four SCTP associations (connected or not) are independent of
>    Override mode.  One would expect that in the normal case, all four
>    SCTP associations are connected.
> 
> 2. Equally, one would expect that in normal operation, all four ASPs are
>    in the ASP-UP state.
> 
> 3. In override mode only one ASP in the AS can be receiving traffic
>    (usually all can send traffic).
> 
> If this arrangement is not just hypothetical, one should really run
> full-mesh with regard to SCTP associations and SGP.  That is, four
> associations should be added: assoc13, assoc14, assoc21 and assoc22.
> Associations are cheap, but failover between ASPs usually is not.
> 
> -- 
> Brian F. G. Bidulock
> [email-masked]
> http://www.openss7.org/

--

---

From: "Barry Nagelberg" <[email-masked]>
Date: Fri, 1 Oct 2010 08:58:12 -0400

Mikhail,

The scenario that you have described is not valid - if SGP_1 and SGP_2 are both part of SG, then there must be
inter-communication between them. Otherwise they are just two independent SGs.

In override mode, from the viewpoint of the SG there will still be only one active ASP in the AS, regardless of whether
or not SGP1 and SGP2 distributed across two hosts.

Barry Nagelberg
Adax, Inc.

-----Original Message-----
From: [email-masked] [mailto:[email-masked]]On
Behalf Of Mikhail Plotkin
Sent: Friday, October 01, 2010 8:38 AM
To: Brian F. G. Bidulock; Chris Benson
Cc: [email-masked]
Subject: Re: [Sigtran] M3UA AS override mode from SGP perspective

Thanks, Chris and Brian!
What I understood is that in my configuration there could be only one active SCTP association, but in general case there
could be more active SCTP associations depending on how many SGPs are connected with the active ASP. That's clear.

Then another question. According to RFC4666 Appendix A, it is possible to have SGP1 and SGP2 distributed between two
hosts. So, ASP1 may activate in SGP1 and then ASP3 may activate in SGP2. If SGP1 and SGP2 have no inter-communication,
ASP1 will not receive Notify (Alternative ASP active), so there will be two active ASPs in the AS which contradicts to
the override concept.
How should this issue be solved? By management layer at the ASP side or by some kind of inter-communication between
SGPs?

Best regards,
Mikhail.

--

_______________________________________________
Sigtran mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/sigtran

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 1 Oct 2010 08:05:15 -0600

Mikhail,

Yes, Barry has explained it.  We decided long ago that SGP must
coordinate amoung themselves within an SG (it makes things much
easier at the ASP).  That assumes some sort of communication if they
are otherwise independent.  When they are at a significant
geographical distance, for redundancy, they would be better
implemented in separate SG.

--brian

Barry Nagelberg wrote:                       (Fri, 01 Oct 2010 08:58:12)
> Mikhail,
> 
> The scenario that you have described is not valid - if SGP_1 and SGP_2
> are both part of SG, then there must be inter-communication between
> them. Otherwise they are just two independent SGs.
> 
> In override mode, from the viewpoint of the SG there will still be
> only one active ASP in the AS, regardless of whether or not SGP1 and
> SGP2 distributed across two hosts.
> 
> Barry Nagelberg
> Adax, Inc.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Mikhail Plotkin <[email-masked]>
Date: Sat, 2 Oct 2010 00:16:32 +0400

Hi,

The issue is clear now.
Thank you for the explanations.

BR/ Mikhail

BFGB> Mikhail,

BFGB> Yes, Barry has explained it.  We decided long ago that SGP must
BFGB> coordinate amoung themselves within an SG (it makes things much
BFGB> easier at the ASP).  That assumes some sort of communication if they
BFGB> are otherwise independent.  When they are at a significant
BFGB> geographical distance, for redundancy, they would be better
BFGB> implemented in separate SG.

BFGB> --brian

BFGB> Barry Nagelberg wrote:                       (Fri, 01 Oct 2010 08:58:12)

---

From: Benjamin Wilson <[email-masked]>
Date: Fri, 1 Oct 2010 16:24:01 -0400

Guys, 

Just thought I'd get some further clarification on Mikhail's issue.
I'm still a bit uncertain about what is expected at the SG.

For example, how would the following be fully meshed sencenario be 
handled?

ASP1 has associations to both SGP1 and SGP2.
ASP1 sends ASPUP (using ASP id 1) to both SGPs.
Both SGPs respond accordingly with ASPUP ACKs.
ASP1 sends an ASPAC (Override mode) to SGP1.

Are both SGPs now supposed to consider the ASP active at the AS through 
"intercommunication"?

If ASP1 then sends an ASPAC to SGP2, does he override himself and
cause a NOTIFY(ALT-ASP-ACTIVE) to be sent from SGP1?  Or is the SGP 
supposed to know
that this the same ASP and DATA messages should now be sent from BOTH SGPs 
to
ASP1?

Cheers,

Ben

From:   Mikhail Plotkin <[email-masked]>
To:     "Brian F. G. Bidulock" <[email-masked]>, Barry Nagelberg 
<[email-masked]>, <[email-masked]>
Date:   10/01/2010 04:17 PM
Subject:        Re: [Sigtran] M3UA AS override mode from SGP perspective
Sent by:        [email-masked]

Hi,

The issue is clear now.

BR/ Mikhail

BFGB> Mikhail,

BFGB> --brian

BFGB> Barry Nagelberg wrote:                       (Fri, 01 Oct 2010 
08:58:12)
>> Just thought I'd get some further clarification on Mikhail's issue.

I'm still a bit uncertain about what is expected at the SG.

For example, how would the following be fully meshed sencenario be 
handled?

ASP1 has associations to both SGP1 and SGP2.
ASP1 sends ASPUP (using ASP id 1) to both SGPs.
Both SGPs respond accordingly with ASPUP ACKs.
ASP1 sends an ASPAC (Override mode) to SGP1.

Are both SGPs now supposed to consider the ASP active at the AS through 
"intercommunication"?

If ASP1 then sends an ASPAC to SGP2, does he override himself and
cause a NOTIFY(ALT-ASP-ACTIVE) to be sent from SGP1?  Or is the SGP 
supposed to know
that this the same ASP and DATA messages should now be sent from BOTH SGPs 
to
ASP1?

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Fri, 1 Oct 2010 18:50:28 -0600

Benjamin,

Benjamin Wilson wrote:                    (Fri, 01 Oct 2010 16:24:01)
>
>    Are both SGPs now supposed to consider the ASP active at the AS
>    through "intercommunication"?

Yes, the same way the SG coordinates other AS state.

>    If ASP1 then sends an ASPAC to SGP2, does he override himself
>    and cause a NOTIFY(ALT-ASP-ACTIVE) to be sent from SGP1?

Re-read RFC 4666/4.3.4.3.  ASPs do not `override themselves'.

>    Or is the SGP supposed to know that this the same ASP and DATA
>    messages should now be sent from BOTH SGPs to ASP1?

Only one ASP is to be active for an AS in override mode.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: "SINGH, VIKRAMJEET (VIKRAMJEET)" <[email-masked]>
Date: Wed, 6 Oct 2010 14:04:15 +0530

Hi All,

 ASP (Network/SUT)----------(ASP-SGP Mode)----------SGP (Tester)

RC=0 in Remote AS configuration on SUT, if it is SGP-ASP mode.

If PSPs  or SGP type, Route Context always 0 on Remote AS.

RC will always be '0' for Remote AS,configured as ASP-SGP mode?

Thanks,
Vikramjeet Singh

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 6 Oct 2010 04:54:01 -0600

SINGH,,

SINGH, VIKRAMJEET (VIKRAMJEET) wrote:        (Wed, 06 Oct 2010 14:04:15)
> RC will always be '0' for Remote AS,configured as ASP-SGP mode?

No, RC will not always be '0'.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Evgenij <[email-masked]>
Date: Wed, 6 Oct 2010 15:56:39 +0400

Brian, I'm confused!

>   (usually all can send traffic).

Does it mean, that ASP can usually send traffic before sending ASP-AC
message?

The RFC4666 says:
If the SGP or IPSP receives any Data messages before an ASP Active message
is received, the SGP or IPSP MAY discard them.
...
In the case of an Override mode AS, receipt of an ASP Active messageat an
SGP causes the (re)direction of all traffic for the AS to the ASP that sent
the ASP Active message.  Any previously active ASP in the AS is now
considered to be in the state ASP-INACTIVE and SHOULD no longer receive
traffic from the SGP within the AS.  The SGP or IPSP then MUST send a Notify
message ("Alternate ASP_Active") to the previously active ASP in the AS and
SHOULD stop traffic to/from that
ASP.  The ASP receiving this Notify MUST consider itself now in the
ASP-INACTIVE state, if it is not already aware of this via inter-ASP
communication with the Overriding ASP.

I thought that data exchange in override mode is normal only for one
ASP-SGP.

2010/10/1 Brian F. G. Bidulock <[email-masked]>

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 6 Oct 2010 16:20:20 -0600

Evgenij,

Yes, I was responsible for those passages.  The SGP has little
choice but to accept messages from the previously active ASP
until it can or does react to the NOTIFY(Alternate ASP_Active).
Because the NOTIFY is not acknolwedged, the SGP cannot really
know when it is reasonable to stop accepting messages, and
therfore are typically set up to always accept them.  The
passages dictate the ASP behaviour, but allow the SGP to never
discard a message.  If the SGP design is so poor that it
discards messages in this case, for example, after dispatching
the Notify, then messages will be lost regardless of the ASP
behavior.  This is why I say that the SGP usually accepts
messages from an ASP even when it is not active.

--brian

Evgenij wrote:                             (Wed, 06 Oct 2010 15:56:39)
>    If the SGP or IPSP receives any Data messages before an ASP Active
>    message is received, the SGP or IPSP MAY discard them.
>    ...
>    In the case of an Override mode AS, receipt of an ASP Active messageat
>    an SGP causes the (re)direction of all traffic for the AS to the ASP
>    that sent the ASP Active message.  Any previously active ASP in the AS
>    is now considered to be in the state ASP-INACTIVE and SHOULD no longer
>    receive traffic from the SGP within the AS.  The SGP or IPSP then MUST
>    send a Notify message ("Alternate ASP_Active") to the previously
>    active ASP in the AS and SHOULD stop traffic to/from that
-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Evgenij <[email-masked]>
Date: Thu, 7 Oct 2010 14:56:18 +0400

Brian, thank you.
It's explained everything.

2010/10/7 Brian F. G. Bidulock <[email-masked]>

---

From: [email-masked]
Date: Thu, 7 Oct 2010 09:02:57 -0400 (EDT)

Brian,

Thanks for your help.  I just want to make sure I understand completely.

Do the following diagrams look correct in your opinion?
(Hopefully this diagram maintains its format  properly)

---------

Consider the following scenario.  ASP1 is member of AS1 (override mode).

   +------+
   | SGP1 |<--------- (Assoc11)
   +------+          \
                       +------+
                       | ASP1 |
                       +------+
   +------+           /
   | SGP2 |<---------- (Assoc12)
   +------+

Is this the correct behavior?

            SGP1            SGP2            ASP1 (Assoc 11)     ASP1
(Assoc 12)
              |               |                   |                   |
              |<---------ASPUP (ASP ID=1)---------|                   |
              |----------ASP UP Ack ------------->|                   |
              |               |                   |                   |
              |<---------ASP Act. (RC=1) ---------|                   |
              |-----------ASP Act. Ack----------->|                   |
              |               |                   |                   |
 <<< MSUs received at SGP2 are directed to ASP1 via SGP1>>>           |
              |               |                   |                   |
-------- SS7 MSU------------->|                   |                   |
              |<--- MSU ------|                   |                   |
              |------------- DATA --------------->|                   |
              |               |                   |                   |
---SS7 MSU--->|------------- DATA --------------->|                   |
              |               |                   |                   |
              |               |<-------ASPUP (ASP ID=1) --------------|
              |               |--------ASP UP Ack ------------------->|
              |               |                   |                   |
 <<<Receiving ASPUP does not change routing of MSUs>>>
              |               |                   |                   |
-------- SS7 MSU------------->|                   |                   |
              |<--- MSU ------|                   |                   |
              |------------- DATA --------------->|                   |
              |               |                   |                   |
---SS7 MSU--->|------------- DATA --------------->|                   |
              |               |                   |                   |
              |<---------------- ASP Act. (RC=1) ---------------------|
              |---------------- ASP Act. ACK ------------------------>|
              |               |                   |                   |
 <<<Receiving ASPAC at SGP2 from same ASP causes change routing MSUs>>>
              |               |                   |                   |
---SS7 MSU--->|------------- DATA --------------->|                   |
-------- SS7 MSU------------->|----------------- DATA --------------->|
              |               |                   |                   |

Cheers,

Ben

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 7 Oct 2010 10:45:36 -0600

bwilson,

[email-masked] wrote:                     (Thu, 07 Oct 2010 09:02:57)
> -------- SS7 MSU------------->|----------------- DATA --------------->|

All except for this last part.  ASP Active to SGP2 does not
necessarily have to change the routing of traffic.  If you
do, you should use the procedures of draft-bidulock-sigtran-corid
or similar to changeback traffic to avoid missequencing.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Andrew Booth <[email-masked]>
Date: Thu, 7 Oct 2010 13:34:09 -0400

Hi Brian,

In the previous diagram there were two associations from the same ASP to two SGPs.  Eventually, both associations were receiving traffic.

Does anything change if the ASP has two associations to the same SGP?

Andrew

[email-masked] wrote: -----

To: [email-masked]
From: "Brian F. G. Bidulock"
Sent by: [email-masked]
Date: 10/07/2010 12:45PM
Cc: Barry Nagelberg <[email-masked]>, [email-masked], [email-masked]
Subject: Re: [Sigtran] M3UA AS override mode from SGP perspective

bwilson,

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Thu, 7 Oct 2010 13:19:55 -0600

Andrew,

You can only have one association between a given ASP/SGP pairing.

--brian

Andrew Booth wrote:                                (Thu, 07 Oct 2010 13:34:09)
> 
>    Hi Brian,
>    In the previous diagram there were two associations from the same ASP
>    to two SGPs.  Eventually, both associations were receiving traffic.

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Andrew Booth <[email-masked]>
Date: Fri, 8 Oct 2010 15:44:26 -0400

Hi Brian,

I've certainly always thought about it that way, but I don't see this as a requirement in the RFC.  Did I miss it?

Will anything break if an ASP has more than one association to an SGP?

Thanks for any info,
Andrew

[email-masked] wrote: -----

To: Andrew Booth <[email-masked]>
From: "Brian F. G. Bidulock"
Sent by: [email-masked]
Date: 10/07/2010 03:20PM
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: [Sigtran] M3UA AS override mode from SGP perspective

Andrew,

--brian

---

From: Chris Benson <[email-masked]>
Date: Fri, 8 Oct 2010 13:03:29 -0700 (PDT)

Andrew,

>>  [...] I don't see this as a requirement in the RFC. Did I miss it?

Brian has better insight as to the intentions of the RFC, but
within my recollection of the final text, the nearest hint we 
get to your first question is in Section 1.3.2.4 of RFC 4666:

   In order to avoid redundant SCTP associations between
   two M3UA peers, one side (client) SHOULD be designated
   to establish the SCTP association, or M3UA configuration 
   information maintained to detect redundant associations
   (e.g., via knowledge of the expected local and remote
   SCTP endpoint addresses).

The RFC doesn't cite redundant associations as a crime.
but read on ...

>>  Will anything break if an ASP has more than one association to an SGP?

I am alsmost sure that the answer to this is yes, because
the assumed ordered capabilities of the underlying transport 
mechanism will no longer be true.  Messages in one association
can of course overtake messages in another association.

If that last viewpoint of mine is true (things will break),
then "no redundant associations" should be treated as a
requirement.

With thanks, from Chris Benson.

On Fri, 8 Oct 2010, Andrew Booth wrote:

>>  Date: Fri, 8 Oct 2010 15:44:26 -0400
>>  From: Andrew Booth <[email-masked]>
>>  To:  <[email-masked]>
>>  Cc:  <[email-masked]>, Andrew Booth <[email-masked]>,  <[email-masked]>,
>>      <[email-masked]>

---

From: Chris Benson <[email-masked]>
Date: Fri, 8 Oct 2010 14:37:57 -0700 (PDT)

Vinkramjeet,

>>  RC=0 in Remote AS configuration on SUT, if it is SGP-ASP mode.

You are in ASP-SGP Mode.  The SUT is an ASP.  These mean
that there is no Remote AS as viewed from the SUT.

No Remote AS means no remote AS Routing Context or value.

This is how I read your original email.  I apologise in
advance if I misunderstood it.

On Wed, 6 Oct 2010, SINGH, VIKRAMJEET (VIKRAMJEET) wrote:

>>  Date: Wed, 6 Oct 2010 14:04:15 +0530
>>  From: "SINGH, VIKRAMJEET (VIKRAMJEET)" <[email-masked]>
>>  To: "[email-masked]" <[email-masked]>
>>  Subject: [Sigtran] RC=0 in Remote AS configuration if it is SGP-ASP mode
>>  
>>  Hi All,
>>  
>>

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Sat, 9 Oct 2010 02:42:57 -0600

Andrew,

Does the RFC make you think that you could get away with forming
two associations from the same `ASP'?  Pretty much assuming that
ASP designers would be netheads and SG designers would be bellheads
we provided the SGP with the power to enforce a single association
from an ASP at all times:

RFC4666/3.8.1 Error (p.65)

  The "ASP Identifier Required" error is sent by an SGP in response to
  an ASP Up message that does not contain an ASP Idetifier parameter
  when the SGP requires one.  The ASP SHOULD resend the ASP Up message
  with an ASP Identifier.

  The "Invalid ASP Identifier" error is sent by an SGP in response to
  an ASP Up message with an invalid (i.e., non-unique) ASP Identifier.

Also, the typical arrangement forseen was that the SGP would act as a
server and the ASP as a client for SCTP connections.

So, when the SGP gets a association attempt from, say, Host A that is
configured for 1 ASP, and has already formed an association and is
ASP Up, it is fully within its rights to simply refuse the second
association.

When Host A is configured for more than one ASP, and the SGP cannot
tell which ASP is connecting at any given time from its source or
destination address and port, it can demand an ASP Identifier (when
one is not provided by the ASP) using the error, "ASP Identifier
Required".  Should the ASP respond with the same ASP Id that was
provided for another association, the SGP sends the error, "Invalid
ASP Identifier".  Because the ASP Id is always unique and because it
MUST be placed in the Notify(Alternate ASP_Active) when available,
there will nevery be any confusion.  One association, one ASP.

Nevertheless, the SGP might not care what the ASP Id's are, and might
not care to have one supplied.  It might just assume that they are
all unique and treat your two associations as going to different ASPs
regardless of whether you view them as the same or not.  In this case
if you view them as one ASP from your end, the SGP will be sending
you Notify(Alternate ASP_Active) on one association when the other
goes ASP Active, with with no ASP Id (you didn't care to provide one).
But then it will be your fault: just view them as two different ASPs,
the same way that the SGP does and you will not have a problem.

Which then begs the question: "Why would you ever need to form two
associations _from_ _the_ _same_ _ASP_??"  Why not simply consider
one association as coming from ASP#1 and the other from ASP#2?  There
is no requirements placed on the mapping of ASPs to hosts or processes
(and the term "process instance" in the ASP definition is really
really vague).

The only need is for the SGP to identify the ASPs at the end of each
association so that it can run its state machines and provide
notifications within the requirements of the RFC.

--brian

Andrew Booth wrote:                         (Fri, 08 Oct 2010 15:44:26)
> 
>    Hi Brian,
>    I've certainly always thought about it that way, but I don't see this
>    as a requirement in the RFC.  Did I miss it?

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Sat, 9 Oct 2010 02:48:04 -0600

Chris,

Chris Benson wrote:                          (Fri, 08 Oct 2010 13:03:29)
> can of course overtake messages in another association.

It makes no difference whether two associations terminate on the
same ASPs or different ASPs with regard to ordering of messages.

> then "no redundant associations" should be treated as a

If your conlusion where valid, M3UA could not use multiple data
streams in an SCTP association.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Ankit Kumar Sharma <[email-masked]>
Date: Sat, 9 Oct 2010 22:50:37 +0530

If you have a single remote AS then there is no need for RC. It becomes
optional.

However, if you are adamant to include it, then set it to whatever(unsigned
int) you want.

cheers
anki
On Wed, Oct 6, 2010 at 2:04 PM, SINGH, VIKRAMJEET (VIKRAMJEET) <

---

From: Chris Benson <[email-masked]>
Date: Mon, 11 Oct 2010 11:02:09 -0700 (PDT)

Brian,

Thank you for your correction.  I wasn't trying to compare
two associations from two ASPs with two associations from
one ASP (only one SGP).  I was comparing two associations
between one ASP SGP pair, with just one association.

I am familar with M3UA implementations (and MTP3-user
applications) that use SLS values (along with other
fields) to expect ordered delivery within a single
data stream (usually by mapping it to one SCTP Stream).
I thus considered that this ordered delivery works when
only one association is available to reach the selected
SGP, and likely will not work when either of two different
associations might be used by M3UA to connect to reach the
same remote SGP.

The above usage scenario suggests only one association
per ASP SGP pair, which agrees with your observation and
recollection of the intent and meaning of the RFCs to
restrict to one association per pair of M3UA peer processes.

Thanks again, from Chris Benson.

On Sat, 9 Oct 2010, Brian F. G. Bidulock wrote:

>>  Date: Sat, 9 Oct 2010 02:48:04 -0600
>>  From: Brian F. G. Bidulock <[email-masked]>
>>  To: Chris Benson <[email-masked]>
>>  Cc: Andrew Booth <[email-masked]>,  <[email-masked]>,  <[email-masked]>,

---

From: Andrew Booth <[email-masked]>
Date: Tue, 12 Oct 2010 16:49:55 -0400

Hi Brian,

I have always interpreted RFC4666 to mean that at an SG, each SCTP association is considered as a separate ASP.  However, I'm not sure that I can defend that view as the only interpretation based on the wording of RFC4666.

Lets suppose that some Unix process acting as an ASP opens up two SCTP associations to an SG.  I can imagine that the ASP vendor might think of this as one ASP opening two associations to the SG while the SG vendor might like to treat each association as a separate ASP.
Could the ASP vendor legitimately claim that an ASPAC message sent from the ASP process to the SG on either of its two associations should make the ASP active on both associations (assuming the SG accepts the ASPAC)?  After all, the language in RFC4666 is all about messages exchanged between ASPs and SGPs, not specifically about associations.

I don't think that is the intent of RFC4666 (among other things it introduces a number of race conditions) but I don't know that I can defend the wording so I thought I should at least check my interpretation before asking other questions.

As for

That depends on whether the ASP vendor expects different behaviour from the SG if the two assocations come "from the same ASP".

Thanks for any info,
Andrew

-----"Brian F. G. Bidulock" <[email-masked]> wrote: -----

To: Andrew Booth <[email-masked]>
From: "Brian F. G. Bidulock" <[email-masked]>
Date: 10/09/2010 04:43AM
Cc: [email-masked], [email-masked], [email-masked]
Subject: Re: [Sigtran] M3UA AS override mode from SGP perspective

Andrew,

--brian

--
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Tue, 12 Oct 2010 15:34:20 -0600

Andrew,

Andrew Booth wrote:                                                 (Tue, 12 Oct 2010 16:49:55)
> 
>    Could the ASP vendor legitimately claim that an ASPAC message sent
>    from the ASP process to the SG on either of its two associations
>    should make the ASP active on both associations (assuming the SG
>    accepts the ASPAC)?  After all, the language in RFC4666 is all about
>    messages exchanged between ASPs and SGPs, not specifically about
>    associations.

No, they cannot.  If you look in Figure 3, SCTP CDI/RI
causes transition from the ASP-ACTIVE and ASP-INACTIVE
state to the ASP-DOWN state.  So, loss of an association
is considered loss of communication with the ASP.  They
might try to convinve themselves that the model supports
it, but it does not.

Also, as I said, the SG can enforce one ASP per association
for these fancy-pants ASP vendors, whoever they might be,
by requiring an ASP Id thus enforcing its uniqueness.  This
is clearly laid out in the RFC, so if they want their ASP
to work with SGs they should certainly support one ASP per
association.

But this discussion is futile: I give ASP designers more
credit than that.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/

---

From: Andrew Booth <[email-masked]>
Date: Wed, 13 Oct 2010 11:37:24 -0400

Hi Brian,

Thanks for the response, I found it quite helpful even if you
found it futile :)

However, I am still confused about the recent thread on override
mode.  Some of the statements seems contradictory to me and I'd
like to be sure I'm drawing the correct conclusions.

Suppose we have an SG with 5 SGPs and 3 SCTP Associations
connecting to each SGP.  As per the discussion we just had, each
SCTP Association is considered by the SG as a separate ASP.
From the SG perspective then, there are 15 ASPs connecting to 5
SGPs, regardless of whether any of the associations terminate at
the "same remote ASP process".

In this configuration, how many ASPs can be active at once for
an AS in Override mode?

(1) At most one ASP, for the entire SG
(2) At most one ASP on each SGP (at most 5 ASPs)
(3) It depends on some other details of the configuration
(4) Other

Andrew

[email-masked] wrote: -----

Date: 10/12/2010 05:34PM

Andrew,

--brian

---

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 13 Oct 2010 18:50:22 -0600

Andrew,

Now you are talking of something different: it is always the
case that at most one ASP can be active for an override AS
for the entire SG.  However, how the SG determines what ASP
is different from what other depends on several things
foreseen by the RFC:

 - whether the SG can identify the ASP by the network address
   that it uses to connect,

 - whether the SG demands an ASP Id and enforces its uniqueness
   per SGP,

 - whether it knows by some other mechanism (such as ASP1 only
   connects to SGP1, ASPn to SGPn).

If the SG plain refuses to identify any ASP, then each ASP should
only connect once and to one SGP to increase interoperability.

You know, I had to fight long and hard to get ASP Id included
in the various SIGTRAN RFCs.  Perhaps now someone can see its
usefulness.

--brian

Andrew Booth wrote:                             (Wed, 13 Oct 2010 11:37:24)
> [1]http://www.openss7.org/
> [2]https://www.ietf.org/mailman/listinfo/sigtran
> 
> References
> 
>    1. http://www.openss7.org/
>    2. https://www.ietf.org/mailman/listinfo/sigtran

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/